--Main frame for addon
local UIConfig = CreateFrame("Frame", "Death_Roll_Frame", UIParent, "BasicFrameTemplateWithInset");
UIConfig:SetSize(200,250)
UIConfig:SetPoint("CENTER", UIParent, "CENTER")
UIConfig:SetMovable(true)
UIConfig:EnableMouse(true)
UIConfig:RegisterForDrag("LeftButton")
UIConfig:SetScript("OnDragStart", UIConfig.StartMoving)
UIConfig:SetScript("OnDragStop", UIConfig.StopMovingOrSizing)
--UIConfig:Hide()

-------------------------------------------------------------------
--Extra frames inside main frame
UIConfig.title = UIConfig:CreateFontString(nil, "OVERLAY");
UIConfig.title:SetFontObject("GameFontNormal");
UIConfig.title:SetPoint("LEFT", UIConfig.TitleBg, "LEFT", 5, 0);
UIConfig.title:SetText("Death Roll");

--Buttons
--Roll
UIConfig.showButton = CreateFrame("Button", "MyButton", UIConfig, "GameMenuButtonTemplate");
UIConfig.showButton:SetPoint("CENTER", UIConfig, "TOP", -47, -43);
UIConfig.showButton:SetSize(90, 30);
UIConfig.showButton:SetText("Roll");
UIConfig.showButton:SetNormalFontObject("GameFontNormalLarge");
UIConfig.showButton:SetHighlightFontObject("GameFontHighlightLarge");
--Restart
UIConfig.delButton = CreateFrame("Button", "MyDelButton", UIConfig, "GameMenuButtonTemplate");
UIConfig.delButton:SetPoint("CENTER", UIConfig, "TOP", 45, -43);
UIConfig.delButton:SetSize(90, 30);
UIConfig.delButton:SetText("Restart");
UIConfig.delButton:SetNormalFontObject("GameFontNormalLarge");
UIConfig.delButton:SetHighlightFontObject("GameFontHighlightLarge");
--Options
--[[
UIConfig.optButton = CreateFrame("Button", "MyDelButton", UIConfig, "GameMenuButtonTemplate");
UIConfig.optButton:SetPoint("TOP", UIConfig, "TOP", 34, 0);
UIConfig.optButton:SetSize(60, 20);
UIConfig.optButton:SetText("Options");
UIConfig.optButton:SetNormalFontObject("GameFontNormalSmall");
UIConfig.optButton:SetHighlightFontObject("GameFontHighlightSmall");
]]

--Extra frame for showing result with Scroll frame
messageframe = CreateFrame("ScrollingMessageFrame", "MyScrollFrame", UIConfig)
messageframe:SetPoint("CENTER", UIConfig, "CENTER", 0, -30)
messageframe:SetSize(180, 190)
messageframe:SetMaxLines(15)
messageframe:SetInsertMode("TOP")
messageframe:SetJustifyH("LEFT")
messageframe:SetFading(false)
messageframe:SetFontObject("GameFontHighlight")
UIParent.messageframe=messageframe

-----------------------------------------------------------------------
--Code
local clickAmount = 0
local upperLimit = 9999
local lowerLimit = 1
local temp = 0
local trash = {}
local textToShow = ""
local prefixText = "text_prefix"
local prefixTemp = "temp_prefix"
UIConfig.delButton:Disable()

local function roll(upNum)
	temp = math.random(1, upNum)
	if temp == lowerLimit then
		return UnitName("player") .. " has WON the game!\n" .. UnitName("player") .. " rolls " .. tostring(temp) .. " (" .. tostring(lowerLimit) .. "-" .. tostring(upNum) .. ")"
	else
		return UnitName("player") .. " rolls " .. tostring(temp) .. " (" .. tostring(lowerLimit) .. "-" .. tostring(upNum) .. ")"
	end
end


UIConfig.showButton:SetScript("OnClick", function(self)
	clickAmount = clickAmount + 1
	if clickAmount==1 then
		textToShow = tostring(roll(upperLimit));
	else
		textToShow = tostring(roll(temp));
	end
	messageframe:AddMessage(textToShow)
	SendAddonMessage("test", "Hallo", "PARTY")
	--SendAddonMessage(prefixTemp, tostring(temp), "PARTY")
	if temp==lowerLimit then
		UIConfig.showButton:Disable()
		UIConfig.delButton:Enable()
	end
end);

UIConfig.delButton:SetScript("OnClick", function(self)
	messageframe:Clear()
	UIConfig.showButton:Enable()
	temp = 0
	clickAmount = 0
	UIConfig.delButton:Disable()
end)

local succes = RegisterAddonMessagePrefix("test")
UIConfig:RegisterEvent("CHAT_MSG_ADDON")
UIConfig:SetScript("OnEvent", function(self, event, prefix, message, channel, sender)
	if (succes == true) then
		if event == "CHAT_MSG_ADDON" then
			if prefix == "test" then
				messageframe:AddMessage(message)
			else
				SendChatMessage("Failed to register the correct one", "PARTY")
			end
		else
			SendChatMessage("Failed to register event", "PARTY")
		end
	else
		SendChatMessage("Failed to register prefix", "PARTY")
	end
end)